/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.battle.DemoResult
 *  fire.pb.battle.Fighter
 *  fire.pb.buff.BuffAgent
 *  fire.pb.buff.BuffPetImpl
 *  fire.pb.buff.BuffRoleImpl
 *  fire.pb.buff.IBuff
 *  fire.pb.buff.Module
 *  fire.pb.buff.RootBuff
 *  fire.pb.buff.single.EPFixedInjure
 *  fire.pb.effect.Role
 *  fire.pb.skill.Result
 *  fire.pb.skill.fight.FightSkill
 *  fire.pb.timer.ScheduledFutureMap
 *  fire.pb.util.Parser
 *  fire.script.AbstractJSEngine
 *  fire.script.JavaScript
 *  org.apache.log4j.Logger
 *  xbean.BattleInfo
 *  xbean.Buff
 *  xbean.Pod
 */
package fire.pb.buff.continual;

import fire.pb.battle.DemoResult;
import fire.pb.battle.Fighter;
import fire.pb.buff.BuffAgent;
import fire.pb.buff.BuffPetImpl;
import fire.pb.buff.BuffRoleImpl;
import fire.pb.buff.IBuff;
import fire.pb.buff.Module;
import fire.pb.buff.RootBuff;
import fire.pb.buff.continual.ConstantlyBuffConfig;
import fire.pb.buff.single.EPFixedInjure;
import fire.pb.effect.Role;
import fire.pb.skill.Result;
import fire.pb.skill.fight.FightSkill;
import fire.pb.timer.ScheduledFutureMap;
import fire.pb.util.Parser;
import fire.script.AbstractJSEngine;
import fire.script.JavaScript;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;
import org.apache.log4j.Logger;
import xbean.BattleInfo;
import xbean.Buff;
import xbean.Pod;

public class ConstantlyBuff
extends RootBuff {
    protected static final Logger logger = Logger.getLogger((String)"BATTLE");
    protected Buff buffBean;
    protected final ConstantlyBuffConfig buffConfig;
    protected int buffId;
    Map<Integer, JavaScript> effects;

    public List<Integer> parseUsedAttrTypes() {
        ArrayList<Integer> usedattrtypea = new ArrayList<Integer>();
        ArrayList usedattrtypeb = new ArrayList();
        for (Map.Entry<Integer, JavaScript> entry : this.effects.entrySet()) {
            entry.getValue().parseUsedAttrTypes(usedattrtypea, usedattrtypeb);
        }
        return usedattrtypea;
    }

    public ConstantlyBuff(Buff buffBean) {
        this.buffId = buffBean.getIndex();
        this.buffBean = buffBean;
        this.buffConfig = Module.getInstance().getDefaultCBuffConfig(this.buffId);
        if (this.buffConfig.getRoundBuffEffectJavaScript() != null) {
            try {
                this.effects = Parser.parseFightJsEffects((String)this.buffConfig.getRoundBuffEffectJavaScript());
            }
            catch (Exception e) {
                throw new RuntimeException(e);
            }
        }
    }

    public ConstantlyBuff(ConstantlyBuffConfig buffConfig) {
        this.buffConfig = buffConfig;
        this.buffId = buffConfig.getBuffTypeId();
        this.initialBuffBean();
    }

    protected void initialBuffBean() {
        this.buffBean = Pod.newBuff();
        this.buffBean.setIndex(this.buffConfig.getBuffTypeId());
        this.buffBean.setValue(this.buffConfig.getInitValue());
        this.buffBean.setRound(this.buffConfig.getInitRound());
        this.buffBean.setRemaintime(this.buffConfig.getInitTime());
        for (int effectTypeId : this.buffConfig.getEffects().keySet()) {
            this.buffBean.getEffects().put(effectTypeId, this.buffConfig.getEffects().get(effectTypeId));
        }
        if (this.buffConfig.getRoundBuffEffectJavaScript() != null) {
            try {
                this.effects = Parser.parseFightJsEffects((String)this.buffConfig.getRoundBuffEffectJavaScript());
            }
            catch (Exception e) {
                throw new RuntimeException(e);
            }
        }
    }

    public Result impact(BuffAgent buffAgent) {
        ArrayList rmids = new ArrayList();
        for (Map.Entry entry : this.buffBean.getEffects().entrySet()) {
            if (((Float)entry.getValue()).floatValue() != 0.0f) continue;
            rmids.add(entry.getKey());
        }
        for (Integer effectid : rmids) {
            this.buffBean.getEffects().remove(effectid);
        }
        Role erole = buffAgent.getERole();
        Buff oldbuff = buffAgent.addBuffBean(this.buffBean);
        if (oldbuff != null) {
            long rid;
            if (buffAgent instanceof BuffRoleImpl) {
                rid = ((BuffRoleImpl)buffAgent).getRoleId();
                Module.logger.error((Object)("角色" + rid + "的Buff:" + oldbuff.getIndex() + "移除的时候返回不为null"));
            } else if (buffAgent instanceof BuffPetImpl) {
                rid = ((BuffPetImpl)buffAgent).getRoleId();
                Module.logger.error((Object)("角色" + rid + "的宠物Buff:" + oldbuff.getIndex() + "移除的时候返回为null"));
            }
            erole.detachEffects(oldbuff.getEffects());
        }
        erole.attachEffects(this.buffBean.getEffects());
        buffAgent.startBuffTimer(this);
        Result result = new Result(true);
        result.addAddedBuff(this);
        result.updateChangedAttrs(erole.updateAllFinalAttrs());
        return result;
    }

    public Result process(BuffAgent buffAgent) {
        return new Result(false);
    }

    public Result closure(BuffAgent buffAgent) {
        Buff xbuff = buffAgent.removeBuffBean(this.buffBean.getIndex());
        if (xbuff == null) {
            long rid;
            if (buffAgent instanceof BuffRoleImpl) {
                rid = ((BuffRoleImpl)buffAgent).getRoleId();
                Module.logger.error((Object)("角色" + rid + "的Buff:" + this.buffBean.getIndex() + "移除的时候返回为null"));
            } else if (buffAgent instanceof BuffPetImpl) {
                rid = ((BuffPetImpl)buffAgent).getRoleId();
                Module.logger.error((Object)("角色" + rid + "的宠物Buff:" + this.buffBean.getIndex() + "移除的时候返回为null"));
            }
        }
        Role erole = buffAgent.getERole();
        erole.detachEffects(this.buffBean.getEffects());
        Long futureId = (Long)buffAgent.getAgent().getTimerfutures().get(this.buffBean.getIndex());
        if (futureId != null) {
            ScheduledFuture future = ScheduledFutureMap.getInstance().get(futureId.longValue());
            if (future != null) {
                future.cancel(true);
                ScheduledFutureMap.getInstance().remove(futureId.longValue());
            }
            buffAgent.getAgent().getTimerfutures().remove(this.buffBean.getIndex());
        }
        Result result = new Result(true);
        result.addDeletedBuff(this);
        result.setChangedAttrs(erole.updateAllFinalAttrs());
        return result;
    }

    public Result closure(BuffAgent buffAgent, boolean timeout) {
        return this.closure(buffAgent);
    }

    public DemoResult impact(BattleInfo battleInfo, Fighter opfighter, Fighter aimfighter, FightSkill battleskill, Map<Integer, JavaScript> effects) {
        DemoResult demoResult = new DemoResult();
        demoResult.targetid = aimfighter.getFighterId();
        if (effects != null && effects.size() > 0) {
            for (Map.Entry<Integer, JavaScript> entry : effects.entrySet()) {
                try {
                    this.buffBean.getEffects().put(entry.getKey(), Float.valueOf(entry.getValue().eval((AbstractJSEngine)battleInfo.getEngine(), opfighter, aimfighter).floatValue()));
                }
                catch (Exception e) {
                    logger.error((Object)("buffid:" + this.buffId + "entry.getValue:" + entry.getValue().toString() + "entry.getkey()" + entry.getKey()), (Throwable)e);
                    throw new RuntimeException(e);
                }
            }
        } else if (this.effects != null) {
            for (Map.Entry<Integer, JavaScript> entry : this.effects.entrySet()) {
                try {
                    this.buffBean.getEffects().put(entry.getKey(), Float.valueOf(entry.getValue().eval((AbstractJSEngine)battleInfo.getEngine(), opfighter, aimfighter).floatValue()));
                }
                catch (Exception e) {
                    logger.error((Object)("buffid:" + this.buffId + "entry.getValue:" + entry.getValue().toString() + "entry.getkey()" + entry.getKey()), (Throwable)e);
                    throw new RuntimeException(e);
                }
            }
        }
        this.buffBean.setFighterkey(opfighter.getFighterBean().getFighterkey());
        Result result = aimfighter.getBuffAgent().addCBuff(this);
        Module.updateDemoResultFromResult((DemoResult)demoResult, (Result)result, (Fighter)aimfighter);
        return demoResult;
    }

    public DemoResult onRoundEnd(BattleInfo battleInfo, Fighter fighter) {
        Result result;
        DemoResult demo = new DemoResult();
        demo.targetid = fighter.getFighterId();
        boolean changed = false;
        if (this.buffConfig.getRoundBuffId() > 0 && (!fighter.getBuffAgent().existBuff(500033) && !fighter.getBuffAgent().existBuff(509084) || this.getId() == 509084 || this.getId() == 508139)) {
            DemoResult tmpdemo;
            IBuff instantbuff;
            Map<Integer, JavaScript> effects = new HashMap();
            for (Map.Entry entry : this.buffBean.getEffects().entrySet()) {
                JavaScript script = new JavaScript(((Float)entry.getValue()).toString());
                effects.put((Integer)entry.getKey(), script);
            }
            if (effects.size() < 1 && this.buffConfig.getRoundBuffEffectJavaScript() != null) {
                try {
                    effects = Parser.parseFightJsEffects((String)this.buffConfig.getRoundBuffEffectJavaScript());
                }
                catch (Exception e) {
                    e.printStackTrace();
                }
            }
            if ((instantbuff = Module.getInstance().createBuff(this.buffConfig.getRoundBuffId())) instanceof EPFixedInjure && (this.buffConfig.getBuffTypeId() == 509082 || this.buffConfig.getBuffTypeId() == 509083 || this.buffConfig.getBuffTypeId() == 506201)) {
                effects.put(1011, new JavaScript("1"));
            }
            if (fighter.getBuffAgent().canAddBuff(instantbuff.getId()) && (tmpdemo = instantbuff.impact(battleInfo, fighter, fighter, null, effects)) != null) {
                demo = tmpdemo;
                changed = true;
            }
        }
        if ((result = this.roundCountdown(fighter.getBuffAgent())).isSuccess()) {
            Module.updateDemoResultFromResult((DemoResult)demo, (Result)result, (Fighter)fighter);
            changed = true;
        }
        if (changed) {
            return demo;
        }
        return null;
    }

    protected Result roundCountdown(BuffAgent agent) {
        if (this.buffBean.getRound() <= 0) {
            return new Result(false);
        }
        int count = this.buffBean.getRound();
        this.buffBean.setRound(--count);
        if (count == 0) {
            return agent.removeCBuff(this.buffId);
        }
        Result result = new Result(true);
        result.addAddedBuff(this);
        return result;
    }

    public ConstantlyBuff copy() {
        return Module.getInstance().createConstantlyBuff(this.buffBean.copy());
    }

    public ConstantlyBuff copyToData() {
        return Module.getInstance().createConstantlyBuff(this.buffBean.toData());
    }

    public ConstantlyBuffConfig getBuffConfig() {
        return this.buffConfig;
    }

    public Buff getBuffBean() {
        return this.buffBean;
    }

    public long getTime() {
        return this.buffBean.getRemaintime();
    }

    public void setTime(long time) {
        this.buffBean.setRemaintime(time);
    }

    public int getRound() {
        return this.buffBean.getRound();
    }

    public void setRound(int count) {
        this.buffBean.setRound(count);
    }

    public long getAmount() {
        return this.buffBean.getValue();
    }

    public void setAmount(long amount) {
        this.buffBean.setValue(amount);
    }

    public Map<Integer, Float> getEffects() {
        return this.buffBean.getEffects();
    }

    public void setEffects(Map<Integer, Float> effects) {
        this.buffBean.getEffects().clear();
        this.buffBean.getEffects().putAll(effects);
    }

    public int getId() {
        return this.buffId;
    }

    public void setImpactTime(long attachTime) {
        this.buffBean.setImpacttime(attachTime);
    }

    public long getImpactTime() {
        return this.buffBean.getImpacttime();
    }

    public long getRemianingTime(BuffAgent agent) {
        Long futureId = (Long)agent.getAgent().getTimerfutures().get(this.buffId);
        if (futureId == null) {
            return 0L;
        }
        ScheduledFuture timerfuture = ScheduledFutureMap.getInstance().get(futureId.longValue());
        if (timerfuture == null) {
            return 0L;
        }
        long remaintime = timerfuture.getDelay(TimeUnit.MILLISECONDS);
        return remaintime;
    }

    public String toString() {
        return this.buffBean.toString();
    }

    public long getRemainTime() {
        if (this.getTime() <= 0L) {
            return -1L;
        }
        if (this.getImpactTime() <= 0L) {
            return this.getTime();
        }
        return Math.max(0L, this.getTime() - (System.currentTimeMillis() - this.getImpactTime()));
    }

    public long updateCBuffTiming(long totalTime) {
        long currTime = this.buffBean.getRemaintime() + totalTime;
        this.buffBean.setRemaintime(currTime);
        return currTime;
    }
}

